'Ping_Scanradio5.bas
'Es werden im folgenden Programmlisting Teile von Burkhard Kainkas
'Listing LEDmatrix1.bas verwendet, vgl. dazu auch Beitrge zur
'Programmierung der Ping-Pong-Platine 'in BASCOM AVR
'unter www.elo-web.de
'Hermann Nieder
'16.09.14

$crystal = 8000000
$regfile = "m8def.dat"
$hwstack = 64
$swstack = 64
$framesize = 64
'$baud = 9600


Config Scl = Portc.4
Config Sda = Portc.5
Config I2cdelay = 40
I2cinit
'Leds-Array
Dim Leds(12) As Word

Declare Sub Read_reg()
'Declare Sub Standby
Declare Sub Initialisierung

Dim R As Byte
Dim Hi As Byte
Dim Lo As Byte
Dim F As Word
Dim L As Word
Dim F_high As Word
Dim F_low As Word
Dim F_hi As Byte
Dim F_lo As Byte

Dim Zeichen As Byte
Dim Splt1 As Word
Dim Splt2 As Word
Dim Splt3 As Word
Dim Splt11 As Word
Dim Splt12 As Word
Dim Splt13 As Word
Dim Dat As Word
Dim Dat1 As Word
Dim Hi_byte As Word
Dim High_byte As Word
Dim H_byte As Byte
Dim Low_byte As Word
Dim Lo_byte As Byte
Dim L_byte As Byte
Dim Dat_byte As Byte
Dim Zeichen_o As Byte
Dim Zeichen_u As Byte

Dim Dt_h2 As Byte
Dim Dt_h1 As Byte
Dim Splt1o As Word
Dim Splt2o As Word
Dim Splt3o As Word
Dim Splt4o As Word
Dim Splt5o As Word
Dim Splt6o As Word
Dim Splt7o As Word
Dim Splt8o As Word
Dim Splt9o As Word
Dim Splt10o As Word
Dim Splt11o As Word
Dim Splt12o As Word

Dim Splt1u As Word
Dim Splt2u As Word
Dim Splt3u As Word
Dim Splt4u As Word
Dim Splt5u As Word
Dim Splt6u As Word
Dim Splt7u As Word
Dim Splt8u As Word
Dim Splt9u As Word
Dim Splt10u As Word
Dim Splt11u As Word
Dim Splt12u As Word
Dim Leds1u As Word
Dim Leds2u As Word
Dim Leds3u As Word
Dim Leds4u As Word
Dim Leds5u As Word
Dim Leds6u As Word
Dim Leds7u As Word
Dim Leds8u As Word
Dim Leds9u As Word
Dim Leds10u As Word
Dim Leds11u As Word
Dim Leds12u As Word

Dim Z_tausender As Word
Dim Tausender As Word
Dim Hunderter As Word
Dim Zehner As Word
Dim Ziff1_1 As Byte
Dim Ziff1_2 As Byte
Dim Ad_wert As Word



Initialisierung
Anfang:
H_byte = 0
L_byte = 0
Dat_byte = 0
Dat1 = 0

'Zuerst 'Ukw' anzeigen
Gosub Ukw_anzg
Waitms 3000
'Werte fuer Frequenz und Lautstaerke zuerst 0
Gosub Ls_dat
Gosub Dez_darst
Waitms 2000
'darauf Lautstrke des Scanradios auf 'angenehmen' Wert einstellen
R = 4
I2cstart
I2cwbyte &H6E
I2cwbyte R
I2cwbyte 64
I2cwbyte 8
I2cstop
Waitms 1000

Do
Ad_wert = Getadc(7)
If Ad_wert < 400 Then
Gosub Anzeige_min
Goto Loop_end
End If

R = &H13
Read_reg
'Frequenz
F = Hi * 256
F = F + Lo
F = F * 5
F = F + 6400
R = &H04
'Lautstaerke
Read_reg
L = Lo
If Ad_wert > 500 Then
Darstellen:
Dat_byte = L
'zuerst Darstellungswerte fr Laustaerkeanzeige unten bestimmen
Gosub Ls_dat
'danach Darstellungswerte fr Frequenzanzeige oben bestimmen
'und zu einer 'Gesamtanzeige zusammenfassen'
Dat = F
Gosub Dez_darst
End If
Loop_end:
Waitms 2000
Loop


Ls_dat:
Dt_h1 = Dat_byte \ 10
Dt_h2 = Dat_byte Mod 10
Zeichen_u = Dt_h1
Leds1u = 992                                                'Zeichen L
Leds2u = 512                                                ' ""
Leds3u = 512                                                ' ""
Leds4u = 0                                                  'Space
Leds5u = 640
If Dt_h1 = 0 Then
Leds7u = 0
Leds8u = 0
Leds9u = 0
Else
Gosub Zeichen_zu
Leds7u = Splt1u
Leds8u = Splt2u
Leds9u = Splt3u
End If
Zeichen_u = Dt_h2
Gosub Zeichen_zu
Leds10u = Splt1u
Leds11u = Splt2u
Leds12u = Splt3u
Return

'Frequenzdarstellung drei- bzw. vierstellig mit Dezimalpunkt
' z. B. 95.5 fuer 95,5 MHz  oder 107.3 fuer 107,3 MHz

Dez_darst:

'Zehntausender
Z_tausender = Dat \ 10000
'Print Z_tausender 'als Test
'Zeichen_o = Z_tausender
'nur bei Frequenzen ueber 99,9 MHz erfolgt eine vereinfachte Darstellung der '1'
'in den ersten beiden Spalten des Displays auf der Ping-Pong-Platine
If Z_tausender = 1 Then
Ziff1_1 = 2
Ziff1_2 = 31
Else
Ziff1_1 = 0
Ziff1_2 = 0
End If


Leds(1) = Ziff1_1 + Leds1u
Leds(2) = Ziff1_2 + Leds2u


Dat = Dat Mod 10000
Tausender = Dat \ 1000
'Print Tausender 'als Test
Zeichen_o = Tausender
Gosub Zeichen_zo
Leds(3) = Splt1o + Leds3u
Leds(4) = Splt2o + Leds4u
Leds(5) = Splt3o + Leds5u

Dat = Dat Mod 1000
Hunderter = Dat \ 100
Zeichen_o = Hunderter
'Print Hunderter  'Test
Gosub Zeichen_zo
Leds(6) = Splt1o + 0
Leds(7) = Splt2o + Leds7u
Leds(8) = Splt3o + Leds8u

Leds(9) = 16 + Leds9u                                       'Dezimalpunkt oben
Dat = Dat Mod 100
Zehner = Dat \ 10
'Print Zehner   'Test
Zeichen_o = Zehner
Gosub Zeichen_zo
Leds(10) = Splt1o + Leds10u
Leds(11) = Splt2o + Leds11u
Leds(12) = Splt3o + Leds12u


Return

'Die Muster fr die Zeichen (Ziffern der Anzeige)
'wurden mithilfe des Programms "Super-Mustergenerator"
'zu finden unter www.elo-web.de
'entwickelt und die Werte daraus jeweils in die
'Programmzeilen Splt1..Splt3 bernommen.

Zeichen_zo:
'Zeichen in den Zeilen 1 ..5 oben
Select Case Zeichen_o
'Fallunterscheidung fr Muster der Zeichen 0..9 oben
Case 0:
Splt1o = 31
Splt2o = 17
Splt3o = 31

Case 1:
Splt1o = 2
Splt2o = 31
Splt3o = 0

Case 2:
Splt1o = 29
Splt2o = 21
Splt3o = 23

Case 3:
Splt1o = 21
Splt2o = 21
Splt3o = 31

Case 4:
Splt1o = 7
Splt2o = 4
Splt3o = 31
Case 5:
Splt1o = 23
Splt2o = 21
Splt3o = 29

Case 6:
Splt1o = 31
Splt2o = 21
Splt3o = 29

Case 7:
Splt1o = 1
Splt2o = 1
Splt3o = 31

Case 8:
Splt1o = 31
Splt2o = 21
Splt3o = 31

Case 9:
Splt1o = 23
Splt2o = 21
Splt3o = 31

End Select
Return

Zeichen_zu:
'Zeichen in den Zeilen 6..10
Select Case Zeichen_u
'Fallunterscheidung fr Muster der Zeichen 0..9 unten
Case 0:
Splt1u = 992
Splt2u = 544
Splt3u = 992

Case 1:
Splt1u = 64
Splt2u = 992
Splt3u = 0

Case 2:
Splt1u = 928
Splt2u = 672
Splt3u = 736

Case 3:
Splt1u = 544
Splt2u = 672
Splt3u = 992

Case 4:
Splt1u = 224
Splt2u = 128
Splt3u = 992

Case 5:
Splt1u = 736
Splt2u = 672
Splt3u = 928

Case 6:
Splt1u = 992
Splt2u = 672
Splt3u = 928

Case 7:
Splt1u = 32
Splt2u = 32
Splt3u = 992

Case 8:
Splt1u = 992
Splt2u = 672
Splt3u = 992

Case 9:
Splt1u = 736
Splt2u = 672
Splt3u = 992

End Select

Return


Ukw_anzg:
Leds(1) = 124
Leds(2) = 64
Leds(3) = 124
Leds(4) = 0
Leds(5) = 124
Leds(6) = 16
Leds(7) = 104
Leds(8) = 56
Leds(9) = 64
Leds(10) = 48
Leds(11) = 64
Leds(12) = 56
Return

Anzeige_min:
Leds(1) = 0
Leds(2) = 0
Leds(3) = 16
Leds(4) = 16
Leds(5) = 0
Leds(6) = 0
Leds(7) = 16
Leds(8) = 16
Leds(9) = 0
Leds(10) = 0
Leds(11) = 16
Leds(12) = 16
Return

'******************  Service-Unterprogramme *********************


Sub Initialisierung
  Config Portc = 15                                         'PORTC als AD-Eingang
  Config Portb = Output
  'Config Portd = 255
  Ddrd = &B11110010
  Config Timer2 = Timer , Prescale = 8
  On Ovf2 Tim2_isr
  Enable Timer2
  Enable Interrupts
  Start Timer2
  Config Adc = Single , Prescaler = 64 , Reference = Off
  Start Adc

  End Sub


Return



'******************************* Interrupt - Display ****************************

Dim Vy As Byte
Dim Col As Byte
Dim Portdout As Byte
Dim Portcout As Byte


Tim2_isr:
 '800 s
'Timer2 = 56
Col = Col + 1
If Col = 13 Then Col = 1
Vy = Col + 0
Portd = 0
Portb = 0
Portc = 0
If Col = 1 Then Portb.4 = 0 Else Portb.4 = 1
Portb.3 = 1                                                 'cl
Portb.3 = 0
Portb.2 = 1                                                 'Str
Portb.2 = 0
Portdout = Low(leds(vy))
Portcout = Portdout And 15
Portdout = Portdout And 240
Portd = Portdout
Portc = Portcout
Portb = High(leds(vy))
'Waitms 500
Return

Sub Read_reg()
I2cstart
I2cwbyte &H6E
I2cwbyte R
I2cstart
I2cwbyte &H6F
I2crbyte Hi , Ack
I2crbyte Lo , Nack
I2cstop
End Sub

End